import re
import uuid
import functools
import time
import logging
import socket

LOG = logging.getLogger(__name__)


def to_snake_case(camel_str):
    return re.sub("([A-Z0-9])", r"_\1", camel_str).lower().lstrip("_")


def generate_uuid():
    return str(uuid.uuid4())


def is_debugger():
    debuggers = ["172.18.0.4"]
    addr = socket.gethostbyname(socket.gethostname())

    return addr in debuggers


def time_debugger(func):
    @functools.wraps(func)
    def inner_func(*args, **kwargs):

        start = time.perf_counter()
        result = func(*args, **kwargs)
        end = time.perf_counter()

        log_msg = ""
        log_msg += f"""
    Query_debugger: Function : {func.__name__}
    Query_debugger: Finished in : {(end - start):.10f}s
        """
        LOG.info(log_msg)
        return result

    return inner_func
